#pragma once

#include "Layout.h"
#include "ScriptletContainerFactory.h"
#include "NPSingleton.h"

class NPCOMMONUI_API AbsoluteLayoutManager : public ILayoutManager
{
public:
	DECLARE_PROPERTY_CONTAINER(AbsoluteLayoutManager);
	DECLARE_SINGLETON_CODE(AbsoluteLayoutManager);
	AbsoluteLayoutManager() {}
	virtual ~AbsoluteLayoutManager() {}

	//override
	void LayoutContainer(CContainer* pParent)
	{
		CRect rcClient;
		pParent->GetDrawingBounds(&rcClient);

		CAtlList<CComponent*> lstChild;
		pParent->GetChildList(lstChild);
		
		CRect rcPadding;
		pParent->GetPadding(&rcPadding);
		
		CRect rcBound;
		POSITION pos = lstChild.GetHeadPosition();
		while (pos)
		{
			CComponent* pChild = lstChild.GetNext(pos);
			pChild->GetBounds(&rcBound);
			pChild->GetPadding(&rcPadding);

			if (rcBound.Width() == 0 || rcBound.Height() == 0)
			{
				CSize sizePreferredChild;
				pChild->GetPreferredSize(&sizePreferredChild);

				if (rcBound.Width() == 0)
				{
					rcBound.right = rcBound.left + sizePreferredChild.cx;
				}
				if (rcBound.Height() == 0)
				{
					rcBound.bottom = rcBound.top + sizePreferredChild.cy;
				}				
			}	
			pChild->SetActualBound(rcPadding.left + rcBound.left, rcPadding.top + rcBound.top, rcBound.Width(), rcBound.Height());
		}
	}
};